{%- import "src/_utils.j2" as utils with context -%}

{#- ----------------------------------------------------------------------- -#}
{#-  GLOBAL VARIABLES                                                       -#}
{#- ----------------------------------------------------------------------- -#}

{#- this global namespace stack will be used to pass vars from macros defined here -#}
{#- to their callers  -#}
{%- set global_ns = namespace(description="tree_utils") -%}
{%- set global_ns.var_stack = [] -%}


{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="local") -%}

{%- macro updateChildOfRelations(globals, parent, child) -%}

  {%- if child -%}
    {%- set child_of_relations = globals.global_ns.main_vars.child_of_relations -%}
    {%- set local_ns.found = false -%}
    {%- for item in child_of_relations -%}
      {%- if child in item -%}
        {%- set local_ns.found = true -%}
        
        {%- set key = child -%}
        {%- set value = item[key] -%}
        {%- do value.append(parent) -%} 
      {%- endif -%}
    {%- endfor -%}

    {%- if not local_ns.found -%}
      {%- set value = [] -%}
      {%- do value.append(parent) -%}
      {%- set node = { child : value } -%}
      {%- do child_of_relations.append(node) -%}
    {%- endif -%}
  {%- endif -%}
{#- {{ "child " ~ child ~ " parent " ~ parent ~ " list " ~ child_of_relations }} -#}
{%- endmacro -%}

{%- macro isChildOf(globals, child, target) -%}

  {%- set child_of_relations = globals.global_ns.main_vars.child_of_relations -%}
  {%- set local_ns.answer = false -%}
  {%- set local_ns.child = child -%}

  {%- if local_ns.child and target -%}
    {%- for item in child_of_relations recursive -%}
      {%- set outer_loop = loop -%}
       
      {%- if local_ns.child in item -%}
        {%- set direct_parent = item[local_ns.child] -%}
  {#-      {%- if target == "bb47bd05-dfd3-4b6f-bc7c-8061447374b9" -%} -#}
  {#-        {{ " child " ~ local_ns.child ~ " target " ~ target ~ " direct_parent " ~ direct_parent }} -#}
  {#-      {%- endif -%} -#}
        {%- for uuid in direct_parent -%}
          {%- set local_ns.child = uuid -%}
          {%- if local_ns.child == target -%}
            {%- set local_ns.answer = true -%}
            {#- base case -#}
          {%- else -%}
            {{ outer_loop(child_of_relations) }}
          {%- endif -%}
        {%- endfor -%}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}

  {%- do global_ns.var_stack.append(local_ns.answer) -%}
{%- endmacro -%}
